#!/usr/bin/python
# Copyright 2015 (c) Anna Schumaker.

import slack
import smtplib
from email.mime.text import MIMEText
import textwrap


smtp  = smtplib.SMTP("localhost")
reply = "--- Reply above this line ---".ljust(40)

def mail_thread(thread):
    if not thread.is_member():
        return
    if (thread.unread_count() == 0) or (thread.unread_count() == None):
        return

    header = ("thread=%s" % thread.id()).rjust(40)
    header = "%s%s" % (reply, header)
    text   = [ header, "" ]
    for message in thread.read():
        text += [ str(message) ]

    print("\n".join(text))
    print()

    msg = MIMEText("\n".join(text))
    msg["Subject"] = "[%s] %s" % (slack.team(), thread.name())
    msg["From"] = "SlackMail@OcarinaProject.net"
    msg["To"] = slack.user().email()
    smtp.sendmail(slack.team(), slack.user().email(), msg.as_string())

def mail_threads(thread_list):
    for thread in thread_list:
        mail_thread(thread)

mail_threads(slack.channels.list())
mail_threads(slack.groups.list())
smtp.quit()
